#include <cb2/Application.h>
#include <cb2/Containers.h>
#include <cb2/Paragraph.h>
#include <cb2/Forms.h>
#include "common.h"


using namespace CB2;


class App : public Application {
	public:
		App();
};


App::App()
	: Application() {
	const Serializer & data = Serializer::GetSerializer();
	
	String body_anchor = "BODY";
	SetTemplate(new SimpleAppTemplate("Form application", body_anchor), body_anchor);
	
	ContainerBin * bin = new ContainerBin(*this);
	
	new Heading(*bin, 1, "Form sample");
	
	MapList options;
	options << Map(1, "Pick me");
	options << Map(2, "No, pick me!");
	
	Form * form = new Form(*bin);
	new InputBox(*form, "string", "");
	new ListBox(*form, "list", options);
	new Button(*form, Button::button_submit, "OK");
	
	new Spacer(*bin, Size(3, Size::em));
	
	new Heading(*bin, 2, "GET variables");
	for (MapList::iterator it = data.GetVars.Begin(); it != data.GetVars.End(); ++it) {
		Text text;

		text << TT << STRONG << it->GetKey() << NO_STRONG << "=" << it->GetValue() << NO_TT;
		new Paragraph(*bin, text);
	}
	
	new Heading(*bin, 2, "POST variables");
	for (MapList::iterator it = data.PostVars.Begin(); it != data.PostVars.End(); ++it) {
		Text text;
		
		text << TT << STRONG << it->GetKey() << NO_STRONG << "=" << it->GetValue() << NO_TT;
		new Paragraph(*bin, text);
	}
}


CB2_IMPLEMENT_APP(App);
