/***********************************************************************

  ColorBox2: Containers.cpp
    (c) 2004 by Martin Decky
  
  Distributed under the terms of Lesser General Public Licence, see
  COPYING.

  0.3			20th August 2004	initial

***********************************************************************/


#include <cb2/Containers.h>


using namespace CB2;


ContainerBin::ContainerBin(Container & parent, const String & css_class, const String & css_id)
	: Container(parent) {
	init(css_class, css_id);
}


ContainerBin::ContainerBin(Application & parent, const String & css_class, const String & css_id)
	: Container(parent) {
	init(css_class, css_id);
}


ContainerBin::~ContainerBin() {
	done();
	
	for (container_list::iterator it = members.Begin(); it != members.End(); ++it)
		delete &(*it);
		
	Data(mtempl->Render());
	delete mtempl;
}


Template * ContainerBin::Add(Widget * child, String & anchor) {
	anchor = String("BIN") + String(members.Len());
	(*mtempl) += String("&&") + anchor + String(";");
	members << child;
	
	return mtempl;
}


void ContainerBin::init(const String & css_class, const String & css_id) {
	String tmp;
	
	if ((css_class != "") || (css_id != "")) {
		div = true;
		tmp = "<div";
		
		if (css_id != "")
			tmp += String(" id=\"") + css_id.HTML() + String("\"");
		
		if (css_class != "")
			tmp += String(" class=\"") + css_class.HTML() + String("\"");
		
		tmp += ">";
	}

	mtempl = new Template(tmp);
}


void ContainerBin::done() {
	if (div)
		(*mtempl) += "</div>";
}
