/***********************************************************************

  ColorBox2: Containers.h
    (c) 2004 by Martin Decky
  
  Distributed under the terms of Lesser General Public Licence, see
  COPYING.

  0.3			20th August 2004	initial

***********************************************************************/


#ifndef __CB2__CONTAINERS_H__
#define __CB2__CONTAINERS_H__


#include <cb2/utils.h>
#include <cb2/Widgets.h>


namespace CB2 {
	
	
	/** Linear storage of widgets
	 *
	 * This container implements the simples
	 * storage of widgets each after another
	 * without any layout.
	 *
	 */
	class ContainerBin : public Container {
		public:
			ContainerBin(Container & parent, const String & css_class = "", const String & css_id = "");
			ContainerBin(Application & parent, const String & css_class = "", const String & css_id = "");
			virtual ~ContainerBin();
			
			virtual Template * Add(Widget * child, String & anchor);
			
		private:
		
			typedef List< Widget> container_list;
			
			void init(const String & css_class, const String & css_id);
			void done();
			
			bool div;
			Template * mtempl;
			container_list members;
	};
	
}


#endif
