/***********************************************************************

  ColorBox2: Template.cpp
    (c) 2004 by Martin Decky
  
  Distributed under the terms of Lesser General Public Licence, see
  COPYING.

  0.3			20th August 2004	initial

***********************************************************************/


#ifndef __CB2__TEMPLATE_H__
#define __CB2__TEMPLATE_H__


#include <cb2/utils.h>


namespace CB2 {
	
	
	/** Template engine class
	 *
	 * This class stores a visual template
	 * with anchors. These anchors are substituted
	 * by the rendered value of other templates
	 * or rendered widgets.
	 *
	 */
	class Template : public Class {
		public:
			Template();                     /**< Constructor */
			Template(const String & value); /**< Constructor */
			
			const Template & operator+=(const String & right); /**< Append a string to template */
			
			String::size_type Subst(const String & anchor, const String & value);    /**< Substitute an anchor in template */
			String::size_type SubstURL(const String & anchor, const String & value); /**< Substitute an URL anchor in template */
			String Render();                                                         /**< Render template */
			
		private:
			String macro; /**< Template storage */
	};
	
}


#endif
